Subject: Re: [PATCH v11 06/12] seccomp: add system call filtering using BPF

From: Eric Paris <[email-masked]>
Date: Mon, 27 Feb 2012 15:34:39 -0500

On Mon, 2012-02-27 at 12:00 -0800, Kees Cook wrote:
> On Mon, Feb 27, 2012 at 11:25 AM, Eric Paris <[email-masked]> wrote:
> > On Mon, 2012-02-27 at 10:55 -0800, Kees Cook wrote:
> >> On Mon, Feb 27, 2012 at 8:49 AM, Eric Paris <[email-masked]> wrote:
> >
> >> You mean as used in audit_log_exit() ? It looks like that depends on a
> >> lot of state cached in __audit_syscall_entry() and finally triggered
> >> in __audit_syscall_exit() (and ..._free()). I don't think this is
> >> really want seccomp wants to be involved in.
> >>
> >> By CONFIG_AUDITSC, you mean CONFIG_AUDITSYSCALL? Without that set,
> >> audit_seccomp is a no-op.
> >>
> >> The reason compat needs to be reported (or rather, arch) is because
> >> just reporting syscall is ambiguous. It either needs arch or compat to
> >> distinguish it.
> >
> > Yes, that is what I mean and you are right.  You shouldn't push the
> > syscall in this record either.  If !audit_dummy_context() you are
> > already going to get arch, syscall, and a0-a4 in the associated audit
> > record.  Please do not duplicate that info.
> 
> Ah, in that case, please ignore the patch I just sent. Heh.
> 
> > It might make sense to have a separate audit_seccomp() path when
> > audit_dummy_context() which includes arch, syscall, and a0-a4.
> 
> Ah! I think I understand what you mean now. If audit_dummy_context(),
> then the syscall, arch, and a0-a4 were not already collected. Gotcha.
> 
> How do you envision it looking? I still see it as two distinct events
> (the syscall itself, and the rejection). Would you want those details
> added to the context structure to be reported at ..._exit() time? It
> seems like context->type couldn't be used to see if those fields were
> valid.
> 
> Something like:
> 
> void __audit_seccomp(unsigned long syscall, long signr)
> {
>         struct audit_buffer *ab;
> 
>         if (!audit_dummy_context()) {
>                 struct audit_context *context = current->audit_context;
>                 context->syscall_signr = signr;
>                 context->syscall_ip = KSTK_EIP(current);
>                 return;
>         }
> 
>         ab = audit_log_start(NULL, GFP_KERNEL, AUDIT_ANOM_ABEND);
>         audit_log_abend(ab, "seccomp", signr);
>         audit_log_format(ab, " syscall=%ld", syscall);
>         audit_log_format(ab, " ip=0x%lx", KSTK_EIP(current));
>         audit_log_end(ab);
> }
> 
> And then report syscall_ip and syscall_signr if syscall_signr != 0 in
> the _exit()? I think everything else from audit_log_abend() will end
> up in the _exit() report.
> 
> > It is my fault (85e7bac3) that we have syscall at all, but I'm on a new
> > crusade to remove audit record duplication.  So I'd happily see a patch
> > in this series that removes that instead of adds to it.
> 
> Well, I think the abend reporting is nice; I'd hate to see that
> totally removed. The seccomp case is a bit different, I agree. I could
> see it either way.

Once again I send you down a bad path.  Your original patch was the
best.  We should consider including a0-aX in a future version.  I was
mistaken in foolishly believing that audit_syscall_entry() was done
before secure_computing().  But if you look, that isn't the case.
Please pretend I never said anything as you had it right the first time.

-Eric